lparameters tcCaption, ;
	tcZipFile, ;
	tcAppName
local llReturn, ;
	laFiles[1], ;
	lnFiles, ;
	lnI, ;
	lcZipFile

* Wait until the application that called us has terminated. If it doesn't do so
* voluntarily, we'll kill it.

llReturn = WaitForAppTermination(tcCaption)
if not llReturn
	llReturn = KillProcess(tcCaption)
endif not llReturn

* If the application terminated, read the file containing the list of files to
* unzip into an array, erase the list file, and unzip each file.

if llReturn
	lnFiles = alines(laFiles, filetostr(tcZipFile))
	erase (tcZipFile)
	declare integer UnZip ;
		in wwIPStuff.dll ;
		string ZipFile,;
		string Destination,;
		string FileSpec
	for lnI = 1 to lnFiles
		lcZipFile = laFiles[lnI]
		if file(lcZipFile)
			UnZip(fullpath(lcZipFile), sys(5) + curdir(), '*.*')
			erase(lcZipFile)
		endif laFileSizes[lnI] > 0
	next lnI
endif llReturn

* Start the application if one was specified and it exists.

if not empty(tcAppName) and (file(tcAppName) or ;
	file(forceext(tcAppName, 'EXE')))
	run /n1 "&tcAppName"
endif not empty(tcAppName) ...
